/*
    Toolbar.cpp

    NOTE: This file is a generated file.
          Do not modify it by hand!
*/

#include "wpch.hpp"
#include "Toolbar.hpp"


// Code added here will be included at the top of the .CPP file

//  Include definitions for resources.
#include "WRes.h"

Toolbar::Toolbar()
{
    numberOfButtons = currentBitmapIndex = 0 ;
}
Toolbar::~Toolbar()
{
    
}
// Initialises the toolbar.
// parent - the form to which to the toolbar is attached
// style - the initial style of the toolbar (default WTOOLBSWrapable)
// visible - the toolbar's initial visibility (default TRUE)
// dPos - the initial docked position of the toolbar (default WDockTop)
void Toolbar::InitToolbar(WForm *parent, WStyle style , WBool visible , WDockPosition dPos)
{
    this->SetStyle(this->GetStyle() | style) ;
    this->Create(parent) ;
    this->SetVisible(visible) ;
    this->SetDockedParent(parent) ;
    this->SetDockedPosition(dPos) ;
}
// Updates the toolbar (i.e. adds itemInfo and draws toolbar)
void Toolbar::UpdateToolbar()
{
    this->Add(itemInfo) ;
    this->Update(TRUE) ;
}
// Adds a button to the toolbar and stores the relevant information in itemInfo
// id - the resource id of the bitmap
// style - the style of the button (default WTBBPushButton)
// userData - any other data (i.e. menu item) associated with the button
// NOTE : This adds a single button to the toolbar. I have not included support for
// arrays of buttons, or for use of standard lists, simply because I don't use them.
// This functionality should not be difficult to add.
void Toolbar::AddButton(WResourceID id , WToolbarItemStyle style , void *userData )
{
    itemInfo.SetCount(numberOfButtons + 1) ;
    itemInfo[numberOfButtons].style = style ;
    if(style != WTBBSeparator) {
        this->AddBitmap(id, 1) ;
        itemInfo[numberOfButtons].bitmapIndex = currentBitmapIndex ;
        itemInfo[numberOfButtons].userData = userData ;
        if(userData != NULL) {
            itemInfo[numberOfButtons].commandID = ((WMenuItem *)userData)->GetID() ;
        }
        currentBitmapIndex++ ;
    }
    numberOfButtons++ ;
}
// Sets the style of the toolbar to the standard style
void Toolbar::SetStandardToolbar()
{
    WStyle style = (WStyle)(this->GetStyle() ^ (WStyle)0x00000840L) ;
    this->SetStyle(style) ;
    this->Update(TRUE) ;
}
// Sets the style of the coolbar to Microsoft's coolbar, as used in ie3
void Toolbar::SetCoolbar()
{
    this->SetStyle(this->GetStyle() | (WStyle)0x00000840L) ;
}
// Adds an event handler for the toolbar. You can call SetEventHandler from anywhere, but
// I prefer to keep events associated with a particular class somehow connected with that
// class.
// event - the id of the event (eg WClickEvent)
// object - the object containing the handler routine (usually a form)
// handler - the name of the handler routine
// userData - any other data associated with the event (default NULL)
void Toolbar::AddToolbarEventHandler(WEventID event, WObject *object, WEventHandler handler, void *userData )
{
    SetEventHandler(event, object, handler, userData) ;
}
